//Software exemplo para comunicação Modbus Slave
//Será utilizada a interface RS485, mas
//também pode ser utilizado com TTL ou RS232

//Chamada da biblioteca
#include "ModbusRtu.h"

//Pinos auxiliares
#define ENTX_pin 2 //Pino de comunicação RS485

//Configuração da biblioteca Modbus como Mestre
//ID , porta serial , Pino fluxo
Modbus slave(1, Serial2, 2);    //Configuração da porta de comunicação
uint8_t  state = 0;             //Estado de controle da comunicação                     
#define Variaveis 8             //Número de variáveis da tabela de comunicação
uint16_t au16data[Variaveis];   //Array (tabela) de comunicação, nesse caso serão 8 valores

void setup() {
  //Setup das seriais
  Serial.begin(115200);   //USB
  slave.begin(115200);    //RS485

  //Inicializa hardware
  pinMode(ENTX_pin, OUTPUT);

}

void loop() {

  //Atualização da tabela modbus
  state = slave.poll(au16data, Variaveis); 
  //Basta executar a função poll no loop e gerenciar o array no controle
  
}
